
#include <err.h>
#include <stdio.h>
#include <assert.h>


#include <abac_pl.h>

#include "options.h"

extern void abac_print_cred_info(abac_credential_t*, FILE*);

int main(int argc, char **argv) {
    int i, success=0;
    abac_credential_t *cred=NULL;
    abac_credential_t **credentials=NULL;

    options_t opts = { 0, };
    get_options(argc, argv, &opts);
    abac_context_t *ctx = abac_context_new();
    abac_context_load_directory(ctx, opts.keystore);

    if(opts.filename) { 
        credentials = abac_context_credentials(ctx);
        FILE *fp=fopen(opts.filename,"w+");

        if (credentials != NULL) {
            for (i = 0; credentials[i] != NULL; ++i) {
                cred = credentials[i];
                abac_print_cred_info(cred,fp);
            }
            abac_context_credentials_free(credentials);
        }
        fclose(fp);
        return 0;
    }

    char *query=NULL;
    char *with=NULL;
    if(opts.role && opts.principal) {
        query=opts.role;
        with=opts.principal;
        } else {
            if(opts.oset) {
                query=opts.oset;
            } 
            if(opts.principal) {
                with=opts.principal;
            } else if(opts.object) {
                with=opts.object;
            }
            if(with==NULL || query==NULL) {
                puts("prover eeekkk \n");
                assert(0);
            }
    }
    credentials = abac_context_query(ctx,
                            query, with,
                            &success);
    if (success)
        puts("prover success!!");
        else puts("prover failed!!");

    if (credentials != NULL && success) {
        puts("credentials needed :");
        for (i = 0; credentials[i] != NULL; ++i) {
           cred = credentials[i];
           abac_print_cred_info(cred,NULL);
        }
    }
    if(credentials)
        abac_context_credentials_free(credentials);
    abac_context_free(ctx);
    
    return 0;
}
